<?php
/**
 * @author ikke
 * @copyright 2008
 */
 
/** admincontroller.php */
class AdminController
{
	private $status = false;
	
	public function __construct()
	{
		login::check(array('ADMIN'));

	}
	
	public function index ()
	{

		$this->indexAdmin();
	}
	
	public function indexAdmin($sText='',$sTitle='',$sPageTitle='')
	{
		$oView = new view();
		
		$sMainTitle = ( $sTitle ) ? $sTitle : 'CLIPvakanties Admin .::. THE language adventure';
		$sPageTitle = ( $sPageTitle ) ? $sPageTitle : 'Admin Panel';
		$sContent = ( $sText ) ? $sText : 'Home pagina';
		
		$l = new lang;
		$l->getLangBlock('indexNotLogin');
		$l->getLangBlock('controllers');
		
		$lVars = $l->returnVars();
		$oView->assign('sAction',QFrontController::$sAction);
		$oView->assign('l',$lVars);
		$oView->assign('sMainTitle',$sMainTitle);
		$oView->assign('sMainTitle',$sMainTitle);
		$oView->assign('sPageTitle',$sPageTitle);
		$oView->assign('sContentPage',$sContent);
		$oView->assign('aMenu',$this->menu());
		$oView->display('indexAdmin/home.tpl');
	}
	
	private function menu()//To change
	{
		$menu = array(
						'index' => 'Panel',
						'lang' => 'Lang files',
						'log' => 'Log files',
						'block' => 'Block users',
						'moderators' => 'Moderators',
						'logout' => 'Log out',
								
					);
		return $menu;
	}
	
	public function lang()
	{
		list($sAction,$sSubAction,$id) = QFrontController::getUrlParts();
		$aActions = array(
							'blocks' => 'Manage blocks',
							'keys' => 'Manage unique keys'
						);
		
		include_once(BASE_PATH . 'Models/adminLanguagemodel.php');
		$adminLang = new adminLang;
		$oView = new view();
		
		$oView->assign('sLangTag', $sLangTag);
		$oView->assign('sAction', $sAction);
		$oView->assign('sSubAction', $sSubAction);
		$oView->assign('id', $id);
		
		if($sAction && array_key_exists($sAction,$aActions))
		{
			$sPageTitle = $aActions[$sAction];
			
			if($sAction == 'blocks')
			{
				if($sSubAction == 'delete')
				{
					if($id && is_numeric($id) && $id > 0){
						$adminLang->deleteBlock($id);
					}
				}
				
				if($sSubAction == 'edit' && $id)
				{
					if(isset($_POST['updateBlock']) && isset($_POST['sBlockName']) 
								&& strlen($_POST['sBlockName']) && is_numeric($_POST['iSub_from']))
					{
						if($adminLang->updateBlock($id, $_POST['sBlockName'], $_POST['iSub_from'])){
							//Succesfully changed
							$id = $_POST['sBlockName'];
						}
					}
					
					$aBlock = $adminLang->getBlock($id);
					$oView->assign('aBlock',$aBlock);
					$aBlocks = $adminLang->getAllBlocks();//for the select
					$oView->assign('aBlocks', $aBlocks);	
					$sPageTitle .= '  '.$aBlock['block_name'];
					
				}
				
				else {
					if(isset($_POST['addBlock']) && strlen($_POST['sBlockName']) && is_numeric($_POST['iSub_from'])){
						$adminLang->addBlock($_POST['sBlockName'],$_POST['iSub_from']);
					}
					$aBlocks = $adminLang->getAllBlocks();
					$oView->assign('aBlocks', $aBlocks);
				}
				
				
			}
			elseif($sAction == 'keys')
			{
				if($sSubAction == 'delete')
				{
					if($id && is_numeric($id) && $id > 0){
						$adminLang->deleteKey($id);
					}
				}
				
				if($sSubAction == 'edit' && $id)
				{
					
					if(isset($_POST['updateKey']) && isset($_POST['sKeyName']) 
								&& strlen($_POST['sKeyName']) && is_numeric($_POST['fblock_id']))
					{
						if($adminLang->updateKey($id, $_POST['sKeyName'], $_POST['fblock_id'])){
							//Succesfully changed
							$id = $_POST['sKeyName'];
						}
						
						$aKey = $adminLang->getKey($id);
						$aLang = lang::getAllLang();
						foreach($aLang as $iLangId => $sTag){
							if(isset($_POST[$sTag.'Content'])){
								$adminLang->updateKeyContent($aKey['keyid'], $iLangId, $_POST[$sTag.'Content']);
							}
						}
						
						$oView->assign('sExtra','  updated');
					}
					
					$aKey = $adminLang->getKey($id);
					$aKeyContent = $adminLang->getKeyContent($aKey['keyid']);
					$aBlocks = $adminLang->getAllBlocks();//for the select
					$sPageTitle .= '  '.$aKey['lkey'];
					
					$oView->assign('aKey',$aKey);
					$oView->assign('aKeyContent',$aKeyContent);
					$oView->assign('aBlocks', $aBlocks);
					$oView->assign('aLang', lang::getAllLang());
					
				}
				else{
					if(isset($_POST['addKey']) && is_numeric($_POST['fblock_id']) && strlen($_POST['sKeyName'])){
						$adminLang->addKey($_POST['sKeyName'], $_POST['fblock_id']);
					}
					
					$aKeys = $adminLang->getAllKeys();
					$oView->assign('aKeys', $aKeys);
					$aBlocks = $adminLang->getAllBlocks();//for the select
					$oView->assign('aBlocks', $aBlocks);	
				}
			}
		}
		else{//Choose action
			$oView->assign('aActions',$aActions);
			$oView->assign('sAction','');
			$sPageTitle = 'Choose action';			
		}

		$this->indexAdmin($oView->fetch('indexAdmin/lang.tpl'),'Translation files',$sPageTitle);
	}
	
	public function logout()
	{
		login::logout();
		require_once ( BASE_PATH . 'Controllers/defaultcontroller.php' );
		$access = new DefaultController;
		$access->loggedOut();
	}
}
?>