<?php

/**
 * @author www.xgeneral.com
 * @copyright 2008
 */

class Benchmark{
	
	private static $aTiming = array();
	
	public function __construct(){
		self::addInterval('start');
	}
	
	public static function addInterval($sName){
		self::$aTiming[$sName] = self::getTime();
	}
	
	public static function returnBench()
	{
		
		$report = '';
		$prevValue = self::$aTiming['start'];
		foreach(self::$aTiming as $key => $value)
		{
			$report .= $key.' '.round(($value-$prevValue),4).'ms'."\n";
			$prevValue = $value;
		}
		
		return $report;
	}
	private static function getTime()
	{
		return array_sum(explode(' ', microtime()));
	}
}
?>